﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices; //needed for IPC

namespace SimpleIPCClientGUI
{	
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
        [DllImport("user32.dll", SetLastError = true)]
        static extern int FindWindow(string lpClassName, string lpWindowName);
        [DllImport("user32.dll")]
        public static extern int SendMessage(int hWnd, int wMsg, int wParam, ref COPYDATASTRUCT lparam);
        public const int WM_COPYDATA = 0x4A;
        public struct COPYDATASTRUCT
        {
        public IntPtr dwData;
        public int cbData;
        [MarshalAs(UnmanagedType.LPStr)]
        public string lpData;
        }			
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
        static int sendFPCIPCMessage(string ServerID, int MsgType, string msg)
        {
            int hWnd = FindWindow("FPCMsgWindowCls", ServerID);
            Console.WriteLine(hWnd);
            byte[] sarr = System.Text.Encoding.Default.GetBytes(msg);
            int len = sarr.Length;
            COPYDATASTRUCT cds;
            cds.dwData = (IntPtr)MsgType;
            cds.lpData = msg;
            cds.cbData = len + 1;
            return SendMessage(hWnd, WM_COPYDATA, 0, ref cds);
        }		
		
		void CmdSendClick(object sender, EventArgs e)
		{
			txtLog.AppendText("Sending message "+txtMessage.Text+" to ServerID "+txtServerID.Text+System.Environment.NewLine);
			sendFPCIPCMessage(txtServerID.Text,3,txtMessage.Text);						
		}
	}
}
